image: alpine:3.15.0

before_script:
  - ./notify.sh

after_script:
  - ./notify.sh

stages:
  - lint
  - build
  - test
  - deploy

lint:
  image: python:3.9.7
  stage: lint
  script:
    - pip3 install flake8
    - python -m flake8 --count

build-image:
  image: docker:latest
  stage: build
  needs: ["lint"]

  services:
    - docker:dind
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker build --pull -t "registry.gitlab.com/c0mmas/public/$CI_PROJECT_NAME:latest" .
    - docker push "registry.gitlab.com/c0mmas/public/$CI_PROJECT_NAME:latest"

kuber-deploy:
  stage: deploy
  image: bitnami/kubectl
  variables:
    KUBE_CONFIG: $STARTUPSTUDIO_CRED
  script:
    - echo -n $KUBE_CONFIG | base64 -d > /.kube/config
    - kubectl -n gitlab-runner-ns apply -f k8s/deployment.yaml
    - kubectl -n gitlab-runner-ns apply -f k8s/service.yaml
    - kubectl -n gitlab-runner-ns rollout restart  -f k8s/deployment.yaml
